Migrating to FRX
This page was created to guide API developers through possible incompatibilities between FxARX SDK and other CAD SDKs as well as architecture limitations, and how they can overcome such problems offering workarounds or alternative solutions.
1. Read/Update the Profile
ARES Commander doesn’t store the profile in the registry. Instead, it is saved in a XML file in the ARES Commander %APPDATA% folder.
We provide an API in FxARX to read and write profile:
AcApProfileManager::ProfileGetKeyValue //to read a profile setting
AcApProfileManager::ProfileSetKeyValue //to update a profile setting
In both methods, the first parameter is the profile name. In the second parameter, you will specify the profile setting. Please, review the profile.xml to understand the root of each setting. For example to modify/read the profile support paths, you will use:
"/files/support_paths"
or for font paths:
"/files/fonts_paths"
Following code shows how to add programmatically a path to the support paths of the current profile:
void UpdateProfile()
{
//find the profile
CString sProfileName = _T("");
struct resbuf rb;
if (RTNORM != acedGetVar(L"CProfile", &rb))
{
acutDelString(rb.resval.rstring);
return;
}
sProfileName = rb.resval.rstring;
CString newPath = L"C:\\Temp";
ACHAR* pSrcPath = nullptr;
//get current support path content
acProfileManagerPtr()->ProfileGetKeyValue(sProfileName , _T("/files") + _T('/support_paths'), pSrcPath );
CString strNewSupporPaths(pSrcPath);
strNewSupporPaths += _T(";") + newPath;
//set new support path content
acProfileManagerPtr()->ProfileSetKeyValue(sProfileName , _T("/files") + _T('/support_paths'), strNewSupporPaths);
}
2. Native MDI window functions
As the native MFC functions that you can use in FRX projects for operations such as maximizing, minimizing, and restoring the MDI window run into conflict with Qt events, the MDI window will not be updated properly. To avoid such situation, please replace:
CMDIFrameWnd::MDIMaximize
CMDIFrameWnd::MDIMinimize
CMDIFrameWnd::MDIRestore
Move MDI window
Restore MDI window functionality
CMDIChildWnd* pChildWnd = pFrame->MDIGetActive(&bMaximized);
if(bMaximized)
{
WINDOWPLACEMENT wndPlacement;
pChildWnd->GetWindowPlacement(&wndPlacement);
wndPlacement.showCmd = SW_RESTORE;
pChildWnd->SetWindowPlacement(&wndPlacement);
}
and use the methods that FxARX API provides:
void MDIMaximize(CWnd* param_1)
void MDIMinimize(CWnd* param_1)
void MDIRestore(CWnd* param_1)
void MDIMoveWindow( CWnd* param_1, const CRect & rect )
For arranging the child windows of the MDI client, use:
void MDITile(int param_1); // 0 = vertical arragement, 1 = horizontal arrangement
void MDICascade();
3. Replace MFC native CStatusBar with CFxUiStatusBar
The use of native MFC CStatusBar objects inside ARES Commander main frame, could run into conflicts with Qt event processing for that kind of controls. Therefore, FxARX API provides the CFxUiStatusBar interface as replacement for the CStatusBar functionality and handles such situations properly.
The following code:
CStatusBar* statusBar = new CStatusBar;
CMDIFrameWnd* pFramWnd = acedGetAcadFrame();
if(pFramWnd )
{
statusBar->Create(pFramWnd, WS_CHILD | WS_VISIBLE | CBRS_TOP);
pFramWnd->ShowControlBar(statusBar, TRUE, FALSE);
}
Should be replaced with the following code:
CFxUiStatusBar* statusBar = new CFxUiStatusBar;
CMDIFrameWnd* pFramWnd = acedGetAcadFrame();
if(pFramWnd )
{
statusBar->Create(pFramWnd, WS_CHILD | WS_VISIBLE | CBRS_TOP);
pFramWnd->ShowControlBar(statusBar, TRUE, FALSE);
}
4. ControlBar/PaletteSet docking and floating status
Do not use native MFC functions to change the status of the FRX DockControlBars. Instead of that, to dock or make the control floating use the function that FxARX SDK provides:
void CAdUiDockControlBar::DockControlBar( unsigned int param_1, tagRECT * param_2 )
4.1 Floating dock control bar
Example: Your DockControlBar inherits from CAcUiDockControlBar
class MyDockControlBar : public CAcUiDockControlBar
To avoid following case:
MyDockControlBar* pDockBar = new MyDockControlBar;
pDockBar->Create( acedGetAcadFrame(), L"MyFlotingDockBar" );
pDockBar->EnableDocking( CBRS_ALIGN_ANY );
acedGetAcadFrame()->FloatControlBar( pDockBar, CPoint( 0, 0 ), CBRS_ALIGN_TOP ); //MFC function
acedGetAcadFrame()->ShowControlBar( pDockBar, TRUE, TRUE );
It should be written like:
MyDockControlBar* pDockBar = new MyDockControlBar;
pDockBar->Create( acedGetAcadFrame(), L"MyFlotingDockBar" );
pDockBar->EnableDocking( CBRS_ALIGN_ANY );
CRect rect;
pDockBar->GetWindowRect( &rect );
pDockBar->DockControlBar( AFX_IDW_DOCKBAR_FLOAT, rectParent );
acedGetAcadFrame()->ShowControlBar( pDockBar, TRUE, TRUE );
5. Reading AcDbObjects that are already closed
We strongly recommend to not access to closed objects. Please, get object information before they have been closed.
Example, avoid following case:
{
// some code...
AcDbLine* pLine = GetSelectedLineEntity();
pLine->close(); //NOT CORRECT
pLine->objectId();
}
it should be written like:
{
// some code...
AcDbLine* pLine = GetSelectedLineEntity();
pLine->objectId();
pLine->close();
}
6. New AcDbTextStyleTableRecord::setFont method not supported
Currently, we don't support the function:
Acad::ErrorStatus setFont(const ACHAR* pTypeface, Adesk::Boolean bold,
Adesk::Boolean italic, Charset charset,
Autodesk::AutoCAD::PAL::FontUtils::FontPitch pitch,
Autodesk::AutoCAD::PAL::FontUtils::FontFamily family,
bool bAllowMissingFont = false);
but it is replaced with the function:
Acad::ErrorStatus AcDbTextStyleTableRecord::setFont(const ACHAR* pTypeface,
int bold,
int italic,
int charset, int pitchAndFamily);
Following code shows how to use the function:
int pitchAndFamily = VARIABLE_PITCH | FF_MODERN;
Acad::ErrorStatus es = style.setFont( _T("Han_Romanstyle") , 0, 0, DEFAULT_CHARSET, pitchAndFamily);
Similar situation can be applied to:
Acad::ErrorStatus AcDbTextStyleTableRecord::font(ACHAR*& pTypeface,
Adesk::Boolean& bold,
Adesk::Boolean& italic,
Charset& charset,
Autodesk::AutoCAD::PAL::FontUtils::FontPitch& pitch,
Autodesk::AutoCAD::PAL::FontUtils::FontFamily& family )
which it is not currently supported, but instead can be used:
Acad::ErrorStatus AcDbTextStyleTableRecord::font( wchar_t * & param_1, Adesk::Boolean & param_2, Adesk::Boolean & param_3, int & param_4, int & param_5 )const
7. GsView changes
Currently, we are not supporting AcGsModel Object caching facility to client. Besides that we render the objects on client screen by creating different GsDevice and GsView. For this reason, we recommend to call the update of the GsDevice when the GsView is invalidated:
mpView->invalidate();
mpView->getDevice()->update();
Another change is when it is use the function AcGsView::dolly:
//AcGeVector3d pan_vec(-(point.x-mStartPt.x),point.y-mStartPt.y,0); ORIGINAL CODE
AcGeVector3d pan_vec(-(point.x-mStartPt.x),-(point.y-mStartPt.y),0); //FRX WORKAROUND
AcGeMatrix3d vM = mpView->viewingMatrix();
AcGeMatrix3d wD = mpView->worldToDeviceMatrix();
pan_vec.transformBy(mpView->viewingMatrix() * mpView->worldToDeviceMatrix().inverse());
mpView->dolly(pan_vec);
8. AcDbFaceRecord class inheritance
In FxARX context, AcDbFaceRecord inherits from AcDbEntity, while in other platforms the base class is AcDbVertex. Add support in FRX configuration to avoid such situations. E.g:
...
AcDbObjectIterator* pIter = pPolyfacemesh->vertexIterator();
AcDbFaceRecord* pFaceRec;
AcDbVertex* pVertex;
for ( ; !pIter->done(); pIter->step() )
{
es = acdbOpenObject( pVertex, pIter->objectId(), AcDb::kForRead ); //FAILS
...
if ( ( pFaceRec = AcDbFaceRecord::cast( pVertex) ) != NULL )
}
A possible workaround:
AcDbObjectIterator* pIter = pPolyfacemesh->vertexIterator();
AcDbFaceRecord* pFaceRec;
AcDbVertex* pVertex;
AcDbEntity* pEntityFR; // define an AcDbEntity pointer
for ( ; !pIter->done(); pIter->step() )
{
es = acdbOpenObject( pEntityFR, pIter->objectId(), AcDb::kForRead ); //assign entity to the new pointer
...
if ( ( pFaceRec = AcDbFaceRecord::cast( pEntityFR) ) != NULL )
}
9. Update multiple documents
In other CAD platforms, you can update non active document by following the next code:
AcApDocument* pCurDoc = acDocManager->curDocument();
acDocManager->setCurDocument( ptherDoc );
//Update entities in other document such as create, remove or edit.
...
if ( actrTransactionManager )
actrTransactionManager->flushGraphics();
acedUpdateDisplay();
acDocManager->setCurDocument( pCurDoc );
ARES Commander has a limitation on updating non active document. Currently you cannot update those document windows. So, if you want to update the MDI window, you need to activate first the document (setCurDocument 3rd parameter).
AcApDocument* pCurDoc = acDocManager->curDocument();
acDocManager->setCurDocument( pOtherDoc, AcAp::kNone, true );
//Update entities in other document such as create, remove or edit.
...
acDocManager->setCurDocument( pCurDoc, AcAp::kNone, true );
10. Do not directly delete a void*
In C++, a void*
pointer is a generic pointer type that can point to any data type. However, because it is type-agnostic, you cannot directly delete a void*
pointer using delete
or delete[]
because the compiler does not know what type of object it points to, and thus cannot call the appropriate destructor.
Please make sure you cast void*
Back to its original type or inheritance:
void* voidPtr = new AcDbLine();
delete static_cast<AcDbEntity*>(voidPtr);
11. No support for modules created for other CAD applications
Do not try to load modules that are not compiled with ARES supported SDKs. They will fail to load in ARES. Please, share with the API team which modules from other CAD applications, the plugin tries to load.
Please avoid the use of
#pragma comment( lib, "XXX" )
for the libs that are not built under FxARX SDK.
12. AcDbJoinEntityPE
Currently we support AcDbJoinEntityPE in ARES Commander but it requires to initialize the JoinEntityPE. You can loaded like
virtual AcRx::AppRetCode On_kInitAppMsg( void* pkt )
{
AcRx::AppRetCode retCode = AcRxArxApp::On_kInitAppMsg( pkt );
...
acdbInitJoinEntityPE();
return retCode;
}
Do not forget to unload JoinEntityPE module when your plugin is being closed.
virtual AcRx::AppRetCode On_kUnloadAppMsg( void* pkt )
{
AcRx::AppRetCode retCode = AcRxArxApp::On_kUnloadAppMsg( pkt );
...
acdbUninitJoinEntityPE();
return ( retCode );
}